package com.vendor.platform.ui.internal;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.UnsupportedEncodingException;
import java.util.Random;
import org.eclipse.ui.WorkbenchEncoding;

public class RC4 {
  private byte[] state = new byte[256];
  
  private int x;
  
  private int y;
  
  public RC4(String key) throws NullPointerException, UnsupportedEncodingException {
    this(key.getBytes(WorkbenchEncoding.getWorkbenchDefaultEncoding()));
  }
  
  public RC4(byte[] key) throws NullPointerException {
    for (int i = 0; i < 256; i++)
      this.state[i] = (byte)i; 
    this.x = 0;
    this.y = 0;
    int index1 = 0;
    int index2 = 0;
    if (key == null || key.length == 0)
      throw new NullPointerException(); 
    for (int j = 0; j < 256; j++) {
      index2 = (key[index1] & 0xFF) + (this.state[j] & 0xFF) + index2 & 0xFF;
      byte tmp = this.state[j];
      this.state[j] = this.state[index2];
      this.state[index2] = tmp;
      index1 = (index1 + 1) % key.length;
    } 
  }
  
  public byte[] rc4(String data) {
    if (data == null)
      return null; 
    try {
      tmp = data.getBytes(WorkbenchEncoding.getWorkbenchDefaultEncoding());
    } catch (UnsupportedEncodingException e) {
      e.printStackTrace();
      return null;
    } 
    byte[] tmp = rc4(tmp);
    return tmp;
  }
  
  public byte[] rc4(byte[] buf) {
    if (buf == null)
      return null; 
    byte[] result = new byte[buf.length];
    for (int i = 0; i < buf.length; i++) {
      this.x = this.x + 1 & 0xFF;
      this.y = (this.state[this.x] & 0xFF) + this.y & 0xFF;
      byte tmp = this.state[this.x];
      this.state[this.x] = this.state[this.y];
      this.state[this.y] = tmp;
      int xorIndex = (this.state[this.x] & 0xFF) + (this.state[this.y] & 0xFF) & 0xFF;
      result[i] = (byte)(buf[i] ^ this.state[xorIndex]);
    } 
    return result;
  }
  
  private static final Random rand = new Random();
}
